from clifinance.application.dto.expense import ExpenseDTO
from clifinance.domain.expense.gateway import ExpenseGateway
from clifinance.domain.expense.model import Expense


class AddExpense:
    def __init__(
        self,
        gateway: ExpenseGateway,
    ) -> None:
        self.__gateway = gateway

    def __call__(self, expense: ExpenseDTO) -> None:
        self.__gateway.add_expense(
            exp=Expense.create(
                id=expense.id if expense.id else 1,
                type=expense.type,
                date=expense.date,
                amount=expense.amount,
                description=expense.description,
            )
        )
