from clifinance.application.dto.balance import Balance
from clifinance.domain.expense.gateway import ExpenseGateway
from clifinance.domain.expense.model import ExpenseType


class GetBalance:
    def __init__(
        self,
        gateway: ExpenseGateway,
    ) -> None:
        self.__gateway = gateway

    def __call__(self) -> Balance:
        return Balance(
            balance=sum(e.amount.value for e in self.__gateway.get_all_expenses()),
            imcome_balance=sum(e.amount.value for e in self.__gateway.get_all_expenses_by_type(ExpenseType.INCOME)),
            expense_balance=sum(e.amount.value for e in self.__gateway.get_all_expenses_by_type(ExpenseType.EXPENSE)),
        )
