from clifinance.domain.expense.model import (
    Expense,
    ExpenseAmount,
    ExpenseDate,
    ExpenseDescription,
    ExpenseId,
    ExpenseType,
)


def expense_to_json(expense: Expense):
    return {
        "id": expense.id.value,
        "description": expense.description.value,
        "amount": expense.amount.value,
        "date": expense.date,
        "type": expense.type.value,
    }


def expense_from_json(data: dict):
    return Expense(
        id=ExpenseId(data["id"]),
        description=ExpenseDescription(data["description"]),
        amount=ExpenseAmount(data["amount"]),
        date=ExpenseDate(data["date"]),
        type=ExpenseType(data["type"]),
    )
