import argparse

from clifinance.application.dto.expense import ExpenseDTO
from clifinance.main.container import Container


def get_balance(args: argparse.Namespace, ioc: Container) -> None:
    with ioc.provide_get_balance() as usecase:
        print(usecase())
    print()


def select_expenses(args: argparse.Namespace, ioc: Container) -> None:
    print(args)


def add_expense(args: argparse.Namespace, ioc: Container) -> None:
    if not all(args.__dict__.values()):
        raise argparse.ArgumentError(
            argument=None,
            message="All arguments are required: -t, -d, -a, -D",
        )

    with ioc.provide_add_expense() as usecase:
        usecase(
            expense=ExpenseDTO(
                id=args.id if args.__dict__.get("id") else -1,
                type=args.type,
                date=args.date,
                amount=args.amount,
                description=args.description,
            )
        )
